using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;

namespace Program01
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.RadioButton optLine2;
		internal System.Windows.Forms.RadioButton optLine1;
		internal System.Windows.Forms.Button cmdClose;
		internal System.Windows.Forms.Button cmdBlink;
		internal System.Windows.Forms.Button cmdPosition;
		internal System.Windows.Forms.Button cmdClear;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		// Constant variables holding the control command characters.
		private const string CMD_CLEAR = "a";
		private const string CMD_BLINK = "e";
		private const string CMD_BLINKRESET = "d";

		// Constant variable holding the Display name.
		private const string DISPLAY_NAME = "EPSON DM-D30 Display";

		// Variables/Objects.
		PrintDocument pdDisplayClear, pdDisplayPosition, pdDisplayBlink;
		Font controlFont, DMDLineFont;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.optLine2 = new System.Windows.Forms.RadioButton();
			this.optLine1 = new System.Windows.Forms.RadioButton();
			this.cmdClose = new System.Windows.Forms.Button();
			this.cmdBlink = new System.Windows.Forms.Button();
			this.cmdPosition = new System.Windows.Forms.Button();
			this.cmdClear = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// optLine2
			// 
			this.optLine2.Location = new System.Drawing.Point(130, 94);
			this.optLine2.Name = "optLine2";
			this.optLine2.Size = new System.Drawing.Size(143, 22);
			this.optLine2.TabIndex = 11;
			this.optLine2.Text = "DM-D 2nd Line";
			// 
			// optLine1
			// 
			this.optLine1.Checked = true;
			this.optLine1.Location = new System.Drawing.Point(130, 66);
			this.optLine1.Name = "optLine1";
            this.optLine1.Size = new System.Drawing.Size(143, 22);
			this.optLine1.TabIndex = 10;
			this.optLine1.TabStop = true;
			this.optLine1.Text = "DM-D 1st Line";
			// 
			// cmdClose
			// 
			this.cmdClose.Location = new System.Drawing.Point(201, 18);
			this.cmdClose.Name = "cmdClose";
            this.cmdClose.Size = new System.Drawing.Size(75, 22);
			this.cmdClose.TabIndex = 9;
			this.cmdClose.Text = "Close";
			this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
			// 
			// cmdBlink
			// 
			this.cmdBlink.Location = new System.Drawing.Point(17, 114);
			this.cmdBlink.Name = "cmdBlink";
			this.cmdBlink.Size = new System.Drawing.Size(104, 22);
			this.cmdBlink.TabIndex = 8;
			this.cmdBlink.Text = "Blink Characters";
			this.cmdBlink.Click += new System.EventHandler(this.cmdBlink_Click);
			// 
			// cmdPosition
			// 
			this.cmdPosition.Location = new System.Drawing.Point(17, 78);
			this.cmdPosition.Name = "cmdPosition";
			this.cmdPosition.Size = new System.Drawing.Size(104, 21);
			this.cmdPosition.TabIndex = 7;
			this.cmdPosition.Text = "Specify Position";
			this.cmdPosition.Click += new System.EventHandler(this.cmdPosition_Click);
			// 
			// cmdClear
			// 
			this.cmdClear.Location = new System.Drawing.Point(17, 41);
			this.cmdClear.Name = "cmdClear";
			this.cmdClear.Size = new System.Drawing.Size(104, 21);
			this.cmdClear.TabIndex = 6;
			this.cmdClear.Text = "Clear";
			this.cmdClear.Click += new System.EventHandler(this.cmdClear_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(292, 166);
			this.Controls.Add(this.optLine2);
			this.Controls.Add(this.optLine1);
			this.Controls.Add(this.cmdClose);
			this.Controls.Add(this.cmdBlink);
			this.Controls.Add(this.cmdPosition);
			this.Controls.Add(this.cmdClear);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Step1 Alphameric characters display";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// The executed function when the Clear button is clicked.
		private void cmdClear_Click(object sender, System.EventArgs e)
		{
			pdDisplayClear = new PrintDocument();
			pdDisplayClear.PrintController = new StandardPrintController(); //To disable pop-up window that shows the printing progress
			pdDisplayClear.PrintPage += new PrintPageEventHandler(pdDisplayClear_PrintPage);
			pdDisplayClear.PrinterSettings.PrinterName = DISPLAY_NAME;
			SetFont();
			pdDisplayClear.Print();
		}

		// The executed function when the Position button is clicked.
		private void cmdPosition_Click(object sender, System.EventArgs e)
		{
			pdDisplayPosition = new PrintDocument();
			pdDisplayPosition.PrintController = new StandardPrintController(); //To disable pop-up window that shows the printing progress
			pdDisplayPosition.PrintPage += new PrintPageEventHandler(pdDisplayPosition_PrintPage);
			pdDisplayPosition.PrinterSettings.PrinterName = DISPLAY_NAME;
			SetFont();
			pdDisplayPosition.Print();
		}

		// The executed function when the Blink button is clicked.
		private void cmdBlink_Click(object sender, System.EventArgs e)
		{
			pdDisplayBlink = new PrintDocument();
			pdDisplayBlink.PrintController = new StandardPrintController(); //To disable pop-up window that shows the printing progress
			pdDisplayBlink.PrintPage += new PrintPageEventHandler(pdDisplayBlink_PrintPage);
			pdDisplayBlink.PrinterSettings.PrinterName = DISPLAY_NAME;
			SetFont();
			pdDisplayBlink.Print();
		}

		// Sets the Font variables to be used in printing.
		private void SetFont()
		{
			controlFont = new Font("Consolas", 9); //Substituted to Control Font
            if (optLine1.Checked == true)
				DMDLineFont = new Font("Lucida Console", (float)8.5, FontStyle.Regular); //Substituted to DM-D 1st Line Font
			else
				DMDLineFont = new Font("Courier New", (float)8.5, FontStyle.Regular); //Substituted to DM-D 2nd Line Font
		}

		// The event handler function when pdDisplayClear.Print is called.
		// This is where the actual sending of Clear command to the display is made.
		private void pdDisplayClear_PrintPage(object sender, PrintPageEventArgs e)
		{
			// Send the character for Clear command ("a") with the Control Font.
			// Positions of x and y are not important, thus, setting them to zeroes.
			e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0);
            e.Graphics.DrawString(CMD_BLINKRESET, controlFont, Brushes.Black, 0, 0);
			e.HasMorePages = false;
		}

		// The event handler function when pdDisplayPosition.Print is called.
		// This is where the actual sending of string to display is made.
		private void pdDisplayPosition_PrintPage(object sender, PrintPageEventArgs e)
		{
			// Clear the display first before displaying the string.
			e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0);

			// Send the string to the Display with DM-D 1st Line or DM-D 2nd Line font, 
			// depending on the choosen line by the user.
			// Positions of x and y are not important, thus, setting them to zeroes.
			e.Graphics.DrawString("Hello APD!", DMDLineFont, Brushes.Black, 0, 0);
			e.HasMorePages = false;
		}

		// The event handler function when pdDisplayBlink.Print is called.
		// This is where the actual sending of Blink command to the display is made.
		private void pdDisplayBlink_PrintPage(object sender, PrintPageEventArgs e)
		{
			// Send the character for Blink command ("e") with the Control Font.
			// Positions of x and y are not important, thus, setting them to zeroes.
            e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0);
			e.Graphics.DrawString(CMD_BLINK, controlFont, Brushes.Black, 0, 0);

			e.Graphics.DrawString("Hello APD!", DMDLineFont, Brushes.Black, 0, 0);
			e.HasMorePages = false;
		}

		// The executed function when the Close button is clicked.
		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
