using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;

namespace Program04
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button cmdClose;
		internal System.Windows.Forms.Button cmdTotal;
		internal System.Windows.Forms.Button cmdItem;
		internal System.Windows.Forms.Button cmdClear;
        /// <summary>
        /// Variable definition
        /// </summary>
        private System.ComponentModel.Container components = null;

        // Display queue name definition
        private const string DISPLAY_NAME = "EPSON DM-D70 Display";

        // Definition of control characters for control font
        private const string CMD_CLEAR = "a";
        private const string CMD_SLIDE_SHOW_ON = "!";
        private const string CMD_SLIDE_SHOW_OFF = "\"";

        // Definition of control characters for controlA font
        private const string CMD_LAYOUT_CHAR = "P";
        private const string CMD_RED_CHAR = "R";
        private const string CMD_ORG_CHAR = "B";

        // Font definition
        // Use the font name set in [Font Replacement] (Refer to APD6_DMD_Setup manual)
        // Important:The number of point should be 2
        Font ControlFont = new Font("Consolas", (float)2, FontStyle.Regular); //control font;
        Font ControlAFont = new Font("Courier New", (float)2, FontStyle.Regular); //controlA font;
        Font DMDCharacter = new Font("MS Gothic", (float)2, FontStyle.Regular); //DM-D Character font;
        Font QRCodeFont = new Font("Lucida Console", (float)2, FontStyle.Regular); //QR Code font;

        // Define display settings
        // Image area size(Required for displaying image)
        // Refer to Technical Reference Guide for the value
        private const int ImageAreaW = 480;
        private const int ImageAreaH = 400;

        // Text area size(Required for displaying QR code)
        // Refer to Technical Reference Guide for the value
        private const int TextAreaW = 480;
        private const int TextAreaH = 400;

        // QR code size(Required for displaying QR code)
        // Refer to Technical Reference Guide manual for the value
        private const int QRCodeW = 87;
        private const int QRCodeH = 87;

        public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            InitializeDisplay();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.cmdClose = new System.Windows.Forms.Button();
            this.cmdTotal = new System.Windows.Forms.Button();
            this.cmdItem = new System.Windows.Forms.Button();
            this.cmdClear = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // cmdItem
            // 
            this.cmdItem.Location = new System.Drawing.Point(24, 12);
            this.cmdItem.Name = "cmdItem";
            this.cmdItem.Size = new System.Drawing.Size(114, 32);
            this.cmdItem.TabIndex = 7;
            this.cmdItem.Text = "Display Item";
            this.cmdItem.Click += new System.EventHandler(this.cmdItem_Click);
            // 
            // cmdTotal
            // 
            this.cmdTotal.Location = new System.Drawing.Point(176, 12);
            this.cmdTotal.Name = "cmdTotal";
            this.cmdTotal.Size = new System.Drawing.Size(119, 32);
            this.cmdTotal.TabIndex = 8;
            this.cmdTotal.Text = "Display Total";
            this.cmdTotal.Click += new System.EventHandler(this.cmdTotal_Click);
            // 
            // cmdClear
            // 
            this.cmdClear.Location = new System.Drawing.Point(96, 60);
            this.cmdClear.Name = "cmdClear";
            this.cmdClear.Size = new System.Drawing.Size(118, 31);
            this.cmdClear.TabIndex = 6;
            this.cmdClear.Text = "Clear";
            this.cmdClear.Click += new System.EventHandler(this.cmdClear_Click);
            // 
            // cmdClose
            // 
            this.cmdClose.Location = new System.Drawing.Point(220, 106);
            this.cmdClose.Name = "cmdClose";
            this.cmdClose.Size = new System.Drawing.Size(75, 22);
            this.cmdClose.TabIndex = 9;
            this.cmdClose.Text = "Close";
            this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(332, 150);
            this.Controls.Add(this.cmdClose);
            this.Controls.Add(this.cmdTotal);
            this.Controls.Add(this.cmdItem);
            this.Controls.Add(this.cmdClear);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Step4 Portrait Sample";
            this.ResumeLayout(false);

		}
        #endregion
        // Set the layout of the customer display with controlA font
        private void InitializeDisplay()
        {
            PrintDocument pdDisplay = new PrintDocument();
            pdDisplay.PrintController = new StandardPrintController(); // Disable the pop-up window that displays the print progress
            pdDisplay.PrintPage += new PrintPageEventHandler(InitDisplay_PrintPage);
            pdDisplay.PrinterSettings.PrinterName = DISPLAY_NAME;
            pdDisplay.Print();
        }

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        // "Display Item" button processing
        private void cmdItem_Click(object sender, EventArgs e)
        {
            PrintDocument pdDisplay = new PrintDocument();
            pdDisplay.PrintController = new StandardPrintController(); // Disable the pop-up window that displays the print progress
            pdDisplay.PrintPage += new PrintPageEventHandler(pdDisplayItem_PrintPage);
            pdDisplay.PrinterSettings.PrinterName = DISPLAY_NAME;
            pdDisplay.Print();
        }

        // "Display Total" button processing
        private void cmdTotal_Click(object sender, EventArgs e)
        {
            PrintDocument pdDisplay = new PrintDocument();
            pdDisplay.PrintController = new StandardPrintController(); // Disable the pop-up window that displays the print progress
            pdDisplay.PrintPage += new PrintPageEventHandler(pdDisplayTotal_PrintPage);
            pdDisplay.PrinterSettings.PrinterName = DISPLAY_NAME;
            pdDisplay.Print();
        }

        // "Clear" button processing
        private void cmdClear_Click(object sender, System.EventArgs e)
		{
            PrintDocument pdDisplay = new PrintDocument();
            pdDisplay.PrintController = new StandardPrintController(); // Disable the pop-up window that displays the print progress
            pdDisplay.PrintPage += new PrintPageEventHandler(pdDisplayClear_PrintPage);
            pdDisplay.PrinterSettings.PrinterName = DISPLAY_NAME;
            pdDisplay.Print();
		}

        // Callback function registered in layout settings
        private void InitDisplay_PrintPage(object sender, PrintPageEventArgs e)
        {
			// Set layout of a display using a controlA font.
			// It is recommended to set the charecter color and background color.
			// The registry file attached to the sample program has the following settings.
			// - Display mode  ( US (K fn=1 )
			// - Character color ( US (G n=35 )
			// - Background color ( US (H n=35 )
            e.Graphics.DrawString(CMD_LAYOUT_CHAR, ControlAFont, Brushes.Black, 1, 1);
            e.HasMorePages = false;
        }

        // Callback function registered by "Display Item" button processing
        private void pdDisplayItem_PrintPage(object sender, PrintPageEventArgs e)
		{
            // Important:Assign GraphicsUnit.Pixel to PageUnit
            e.Graphics.PageUnit = GraphicsUnit.Pixel;

            // Use the DrawString function to process control font, controlA font and DM-D Character font
            // Important:The processing is performed in the order in which the DrawString function is called
            // When using control font and controlA font, the coordinate specification of DrawString function is ignored

            // Important: It is recommended to clear the display before displaying the text, 
            // as whitespace characters may not be handled in the .NET environment
            // Clear the display using the control font
            e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1);
            // Start a slide show using the control font
            e.Graphics.DrawString(CMD_SLIDE_SHOW_ON, ControlFont, Brushes.Black, 1, 1);


            // Important:Specify the start column line of the text as the start coordinate of the DrawString function
            // Important:Do not specify more than one line of text in a DrawString function
            e.Graphics.DrawString("Item:               ", DMDCharacter, Brushes.Black, 1, 1);
            e.Graphics.DrawString("  Cut & Sewn        ", DMDCharacter, Brushes.Black, 1, 2);
            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 3);
            e.Graphics.DrawString("QTY:              3 ", DMDCharacter, Brushes.Black, 1, 4);
            e.Graphics.DrawString("U.PC:        $45.00 ", DMDCharacter, Brushes.Black, 1, 5);

            // Change the font color to red using the controlA font.
            e.Graphics.DrawString(CMD_RED_CHAR, ControlAFont, Brushes.Black, 1, 1);

            e.Graphics.DrawString("             -22.50 ", DMDCharacter, Brushes.Black, 1, 6);

            // Restore font color using the controlA font
            e.Graphics.DrawString(CMD_ORG_CHAR, ControlAFont, Brushes.Black, 1, 1);

            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 7);
            e.Graphics.DrawString("SubTotal:    $67.50 ", DMDCharacter, Brushes.Black, 1, 8);

            e.HasMorePages = false;
		}

        // Callback function registered by "Display Total" button processing
        private void pdDisplayTotal_PrintPage(object sender, PrintPageEventArgs e)
		{
            // Important:Assign GraphicsUnit.Pixel to PageUnit
            e.Graphics.PageUnit = GraphicsUnit.Pixel;

            // Use the DrawString function to process control font, controlA font and DM-D Character font
            // Important:The processing is performed in the order in which the DrawString function is called
            // When using control font and controlA font, the coordinate specification of DrawString function is ignored

            // Important: It is recommended to clear the display before displaying the text, 
            // as whitespace characters may not be handled in the .NET environment
            // Clear the display using the control font
            e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1);
            // Stop a slide show using the control font
            e.Graphics.DrawString(CMD_SLIDE_SHOW_OFF, ControlFont, Brushes.Black, 1, 1);

            // Important:Specify the start column line of the text as the start coordinate of the DrawString function
            e.Graphics.DrawString("Total:        $67.50", DMDCharacter, Brushes.Black, 1, 1);
            e.Graphics.DrawString("Cash:        $100.00", DMDCharacter, Brushes.Black, 1, 2);
            e.Graphics.DrawString("Change:       $32.50", DMDCharacter, Brushes.Black, 1, 3);
            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 4);
            e.Graphics.DrawString("  Store Information ", DMDCharacter, Brushes.Black, 1, 5);
            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 6);
            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 7);
            e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 8);
            
            // Display QR code using QR code font and DrawString function
            // Important:For the coordinates of the TextOut function, specify the coordinates of the upper left corner of the QR code to be displayed
            // Important:At this time, the origin is the upper left corner of the text area
            // Important:QR code can be displayed only in the text area
            int x = (TextAreaW/2) - (QRCodeW / 2);       //Center of text area
            int y = TextAreaH - QRCodeH;                 //Bottom of text area
            e.Graphics.DrawString("https://epson.jp", QRCodeFont, Brushes.Black, x, y);


            // Display an image with the DrawImage function
            // For the coordinates of the DrawImage function, specify the coordinates of the upper left corner of the image to be displayed
            // At this time, the origin is the upper left corner of the image area
            // Important:Images can be displayed only in the image area, and only the display in the entire image area is supported
            // (That is, the starting coordinate is always (0,0))

            // * This sample is implemented on the assumption that the size of the image area and the size of the displayed image are the same

            Image img = new Bitmap("ThankP.png");
            Rectangle destRect = new Rectangle(0, 0, ImageAreaW, ImageAreaH);

            // Important:Assign -1 to the width and height of the input image. 
            // Because in the .NET environment, if the input image and output image are the same size, the drawing function may not be called.
            e.Graphics.DrawImage(img, destRect,0, 0, ImageAreaW - 1, ImageAreaH - 1, GraphicsUnit.Pixel);

            img.Dispose();
            e.HasMorePages = false;
        }

        // Callback function registered by "Clear" button processing
        private void pdDisplayClear_PrintPage(object sender, PrintPageEventArgs e)
		{
			e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1);
			e.HasMorePages = false;
		}

        // The executed function when the Close button is clicked.
        private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
