// DisplayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Program01.h"
#include "DisplayDlg.h"


// CDisplayDlg dialog

IMPLEMENT_DYNAMIC(CDisplayDlg, CDialog)

CDisplayDlg::CDisplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayDlg::IDD, pParent)
{
	/*
	 * Initially, the position font is set to DM-D 1st Line
	 */
	m_strPositionFont = "DM-D 1st Line";
}

CDisplayDlg::~CDisplayDlg()
{
}

void CDisplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDisplayDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_SPECIFY, &CDisplayDlg::OnBnClickedButtonSpecify)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CDisplayDlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_BLINK, &CDisplayDlg::OnBnClickedButtonBlink)
	ON_BN_CLICKED(IDC_RADIO_LINE1, &CDisplayDlg::OnBnClickedRadioLine)
	ON_BN_CLICKED(IDC_RADIO_LINE2, &CDisplayDlg::OnBnClickedRadioLine)
END_MESSAGE_MAP()


// CDisplayDlg message handlers


BOOL CDisplayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Initialize the radio button selection to "Line1"
	CheckDlgButton(IDC_RADIO_LINE1, 1);

	SetWindowText("Step1  Alphameric characters display");

	SetDlgItemText(IDC_BUTTON_CLEAR, "Clear");
	SetDlgItemText(IDC_BUTTON_SPECIFY, "Specify Position");
	SetDlgItemText(IDC_BUTTON_BLINK, "Blink Characters");
	SetDlgItemText(IDOK, "Close");

	return TRUE;
}

void CDisplayDlg::OnBnClickedRadioLine()
{
	BOOL	isLineOne = FALSE;

	/*
	 * Check if "Line1" or "Line2" radio button is selected.
	 * If the selected button is different from the current position, change the position font,
	 * and display the string again.
	 */
	isLineOne = IsDlgButtonChecked(IDC_RADIO_LINE1);

	if ( isLineOne ) {
		m_strPositionFont = "DM-D 1st Line";
	}
	else {
		m_strPositionFont = "DM-D 2nd Line";
	}

	return;
}

void CDisplayDlg::OnBnClickedButtonSpecify()
{
	CPrintDialog pd(FALSE);
	DOCINFO di; 
	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = "Testing";

	pd.GetDefaults();

	DEVMODE *dm = pd.GetDevMode();

	CDC dc;
	/*
	* Create a device context for displaying to the Customer Display.
	*/
	if(! dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, dm))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	dc.StartDoc(&di);

	/*
	* Clear the customer display using the control font and printing "a"
	*/
	CFont	font, *old;
	font.CreatePointFont(7, "control", &dc);
	old = dc.SelectObject(&font);
	dc.TextOut(0, 0, "a");
	dc.SelectObject(old);
	font.DeleteObject();

	/*
	* Display the text
	*/
	font.CreatePointFont(7, m_strPositionFont, &dc);

	dc.SelectObject(&font);
	dc.TextOut(0, 0, "Hello APD!");
	dc.SelectObject(old);
	font.DeleteObject();

	dc.EndPage();
	dc.EndDoc();
	dc.DeleteDC();

}

void CDisplayDlg::OnBnClickedButtonClear()
{
	CPrintDialog pd(FALSE);
    DOCINFO di;

	/*
	 * Clean the document information structure
	 */
    memset(&di, 0, sizeof(DOCINFO));
    di.cbSize = sizeof(DOCINFO);
    di.lpszDocName = "Testing";

    pd.GetDefaults();

    DEVMODE *dm = pd.GetDevMode();

    CDC dc;
	/* Create a device context for displaying to Customer Display */
	if(! dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, dm))
    {
		AfxMessageBox(_T("Customer display is not available."));
		return;
    }

    dc.StartDoc(&di);

	/*
	 * Clear the customer display using the control font and printing "a"
	 * To turn off the blinking, print "d"
	 */
	CFont	font, *old;
	font.CreatePointFont(7, "control", &dc);
	old = dc.SelectObject(&font);
	dc.TextOut(0, 0, "a");
	dc.TextOut(0, 0, "d");
	dc.SelectObject(old);
	font.DeleteObject();	

    dc.EndPage();
    dc.EndDoc();
    dc.DeleteDC();
}


void CDisplayDlg::OnBnClickedButtonBlink()
{
	CPrintDialog pd(FALSE);
	DOCINFO di;     // must have DOCINFO for CDCStartDoc(DOCINFO)

	/*
	 * Clean the document information structure
	 */
	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = "Testing";

	pd.GetDefaults();

	DEVMODE *dm = pd.GetDevMode();

	CDC dc;
	/* Create a device context for displaying to Customer Display */
	if(! dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, dm))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	dc.StartDoc(&di);

	/*
	 * Blink the display using the control font and printing "e"
	 */
	CFont	font, *old;
	font.CreatePointFont(7, "control", &dc);
	old = dc.SelectObject(&font);
	dc.TextOut(0, 0, "a");
	dc.TextOut(0, 0, "e");
	dc.SelectObject(old);
	font.DeleteObject();

	/*
	 * Display the text using the current position font
	 */
	font.CreatePointFont(7, m_strPositionFont, &dc);

	dc.SelectObject(&font);
	dc.TextOut(0, 0, "Hello APD!");	
	dc.SelectObject(old);
	font.DeleteObject();

	dc.EndPage();
	dc.EndDoc();
	dc.DeleteDC();
}
