﻿// DisplayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Program04.h"
#include "DisplayDlg.h"
#include "atlimage.h"


// CDisplayDlg dialog

IMPLEMENT_DYNAMIC(CDisplayDlg, CDialog)

CDisplayDlg::CDisplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayDlg::IDD, pParent)
{
}

CDisplayDlg::~CDisplayDlg()
{
}

void CDisplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDisplayDlg, CDialog)

	ON_BN_CLICKED(IDC_BUTTON_ITEM, &CDisplayDlg::OnBnClickedButtonItem)
	ON_BN_CLICKED(IDC_BUTTON_TOTAL, &CDisplayDlg::OnBnClickedButtonTotal)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CDisplayDlg::OnBnClickedButtonClear)
END_MESSAGE_MAP()


// CDisplayDlg message handlers


BOOL CDisplayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	

	SetWindowText(_T("Step4 Portrait Sample"));

	SetDlgItemText(IDC_BUTTON_ITEM, _T("Display Item"));
	SetDlgItemText(IDC_BUTTON_TOTAL, _T("Display Total"));
	SetDlgItemText(IDC_BUTTON_CLEAR, _T("Clear"));
	SetDlgItemText(IDOK, _T("Close"));

	InitDisplay();
	return TRUE;
}

void CDisplayDlg::InitDisplay()
{
	DOCINFO di;

	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = _T("Set Layout");

	CDC dc;
	if (!dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, NULL))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	dc.StartDoc(&di);

	// Set layout of a display using a controlA font.
	// It is recommended to set the charecter color and background color.
	// The registry file attached to the sample program has the following settings.
	// - Display mode  ( US (K fn=1 )
	// - Character color ( US (G n=35 )
	// - Background color ( US (H n=35 )
	CFont	font, *old;
	// Definition of controlA font
	// Important:The number of points should be 1.
	font.CreatePointFont(1, _T("controlA"), &dc);
	old = dc.SelectObject(&font);
	dc.TextOut(1, 1, _T("P"));

	dc.SelectObject(old);
	font.DeleteObject();

	dc.EndPage();
	dc.EndDoc();
	dc.DeleteDC();

}

// "Display Item" button processing
void CDisplayDlg::OnBnClickedButtonItem()
{
	DOCINFO di;

	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = _T("View Item");

	CDC dc;
	if (!dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, NULL))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	// Display processing start
	dc.StartDoc(&di);

	// Definition of font
	// Important:The number of points should be 1.
	CFont	ControlFont, ControlAFont, CharacterFont, *old;
	ControlFont.CreatePointFont(1, _T("control"), &dc);
	ControlAFont.CreatePointFont(1, _T("controlA"), &dc);
	CharacterFont.CreatePointFont(1, _T("DM-D Character"), &dc);

	// Use the TextOut function to process control font, controlA font and DM-D Character font
	// Important:The processing is performed in the order in which the TextOut function is called
	// When using control font and controlA font, the coordinate specification of TextOut function is ignored

	// Select control font(old is backup)
	old = dc.SelectObject(&ControlFont);
	// Clear the display using the control font
	dc.TextOut(1, 1, _T("a"));
	
	// Start a slide show using the control font
	dc.TextOut(1, 1, _T("!"));

	// Select controlA font
	dc.SelectObject(&ControlAFont);
	// Restore font color using the controlA font
	dc.TextOut(1, 1, _T("B"));

	// Select DM-D Character font
	dc.SelectObject(&CharacterFont);

	// Important:Specify the start column line of the text as the start coordinate of the TextOut function
	// Important:Do not specify more than one line of text in a TextOut function.
	dc.TextOut(1, 1, _T("Item:               "));
	dc.TextOut(1, 2, _T("  Cut & Sewn        "));
	dc.TextOut(1, 3, _T("                    "));
	dc.TextOut(1, 4, _T("QTY:              3 "));
	dc.TextOut(1, 5, _T("U.PC:        $45.00 "));

	// Select controlA font
	dc.SelectObject(&ControlAFont);
	// Change the font color to red using the controlA font
	dc.TextOut(1, 1, _T("R"));

	// Select DM-D Character font
	dc.SelectObject(&CharacterFont);
	dc.TextOut(1, 6, _T("             -22.50 "));
	
	// Select controlA font
	dc.SelectObject(&ControlAFont);
	// Restore font color using the controlA font
	dc.TextOut(1, 1, _T("B"));

	// Select DM-D Character font
	dc.SelectObject(&CharacterFont);

	dc.TextOut(1, 7, _T("                    "));
	dc.TextOut(1, 8, _T("SubTotal:    $67.50 "));

	dc.SelectObject(old);

	ControlFont.DeleteObject();
	ControlAFont.DeleteObject();
	CharacterFont.DeleteObject();

	dc.EndPage();
	// Display processing end
	dc.EndDoc();
	dc.DeleteDC();

}


// Callback function registered by "Display Total" button processing.
void CDisplayDlg::OnBnClickedButtonTotal()
{
	DOCINFO di;

	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = _T("View Total");

	CDC dc;
	if(! dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, NULL))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	// Display processing start
	dc.StartDoc(&di);

	// Definition of font
	// Important:The number of points should be 1.
	CFont	ControlFont, QRCodeFont, ControlAFont, CharacterFont, *old;
	ControlFont.CreatePointFont(1, _T("control"), &dc);
	ControlAFont.CreatePointFont(1, _T("controlA"), &dc);
	QRCodeFont.CreatePointFont(1, _T("2D-Code1"), &dc);
	CharacterFont.CreatePointFont(1, _T("DM-D Character"), &dc);

	// Use the TextOut function to process control font, controlA font and DM-D Character font
	// Important:The processing is performed in the order in which the TextOut function is called
	// When using control font and controlA font, the coordinate specification of TextOut function is ignored

	// Select control font(old is backup)
	old = dc.SelectObject(&ControlFont);
	// Clear the display using the control font
	dc.TextOut(1, 1, _T("a"));
	
	// Stop a slide show using the control font
	dc.TextOut(1, 1, _T("\""));

	// Select controlA font
	dc.SelectObject(&ControlAFont);
	// Restore font color using the controlA font
	dc.TextOut(1, 1, _T("B"));

	// Select DM-D Character font
	dc.SelectObject(&CharacterFont);
	// Important:Specify the start column line of the text as the start coordinate of the TextOut function
	// Important:Do not specify more than one line of text in a TextOut function
	dc.TextOut(1, 1, _T("Total:        $67.50"));
	dc.TextOut(1, 2, _T("Cash:        $100.00"));
	dc.TextOut(1, 3, _T("Change:       $32.50"));
	dc.TextOut(1, 4, _T("                    "));
	dc.TextOut(1, 5, _T("  Store Information "));
	dc.TextOut(1, 6, _T("                    "));
	dc.TextOut(1, 7, _T("                    "));
	dc.TextOut(1, 8, _T("                    "));


	// Select QR Code font
	dc.SelectObject(&QRCodeFont);
	// Display QR code using QR code font and TextOut function
	// Important:For the coordinates of the TextOut function, specify the coordinates of the upper left corner of the QR code to be displayed
	// Important:At this time, the origin is the upper left corner of the text area
	// Important:QR code can be displayed only in the text area

	// Text area size
	// Refer to the Technical Reference Guide for the value
	int TextAreaW = 480;
	int TextAreaH = 400;

	// QR code size
	// Refer to the Technical Reference Guide for the value
	int QRCodeW = 87;
	int QRCodeH = 87;

	int x = (TextAreaW/2) - (QRCodeW / 2);       //Center of text area
	int y = TextAreaH - QRCodeH;                 //Bottom of text area

	dc.TextOut(x, y, _T("https://epson.jp"));

	// Display an image with the BitBlt function of the CImage class
	// For the coordinates of the BitBlt function, specify the coordinates of the upper left corner of the image to be displayed
	// At this time, the origin is the upper left corner of the image area
	// Important:Images can be displayed only in the image area, and only the display in the entire image area is supported.
	// (That is, the starting coordinate is always (0,0)
	// Refer to the Technical Reference Guide for the size of image area

	// * This sample is implemented on the assumption that the size of the image area and the size of the displayed image are the same
	CImage image;
	image.Load(_T("ThankP.png"));
	image.BitBlt(dc.GetSafeHdc(), 0, 0);

	dc.SelectObject(old);

	ControlFont.DeleteObject();
	ControlAFont.DeleteObject();
	QRCodeFont.DeleteObject();
	CharacterFont.DeleteObject();


	dc.EndPage();
	dc.EndDoc();
	dc.DeleteDC();
}

void CDisplayDlg::OnBnClickedButtonClear()
{
	DOCINFO di;

	/*
	 * Clean the document information structure
	 */
	memset(&di, 0, sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = _T("Clear");

	CDC dc;
	/* Create a device context for displaying to Customer Display */
	if (!dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, NULL))
	{
		AfxMessageBox(_T("Customer display is not available."));
		return;
	}

	dc.StartDoc(&di);

	/*
	 * Clear the customer display using the control font and printing "a"
	 */
	CFont	font, *old;
	font.CreatePointFont(1, _T("control"), &dc);
	old = dc.SelectObject(&font);
	dc.TextOut(0, 0, _T("a"));
	dc.SelectObject(old);
	font.DeleteObject();

	dc.EndPage();
	dc.EndDoc();
	dc.DeleteDC();
}
