Imports System.Drawing.Printing

Public Class Form1
    Inherits System.Windows.Forms.Form

    ' Constant variables holding the control command characters.
    Private Const CMD_CLEAR As String = "a"
    Private Const CMD_BLINK As String = "e"
    Private Const CMD_BLINKRESET As String = "d"

    ' Constant variable holding the Display name.
    Private Const DISPLAY_NAME As String = "EPSON DM-D30 Display"

    ' Variables/Objects.
    Private WithEvents pdDisplayClear As PrintDocument
    Private WithEvents pdDisplayPosition As PrintDocument
    Private WithEvents pdDisplayBlink As PrintDocument
    Dim controlFont As Font
    Dim DMDLineFont As Font

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents optLine1 As System.Windows.Forms.RadioButton
    Friend WithEvents optLine2 As System.Windows.Forms.RadioButton
    Friend WithEvents cmdClear As System.Windows.Forms.Button
    Friend WithEvents cmdPosition As System.Windows.Forms.Button
    Friend WithEvents cmdBlink As System.Windows.Forms.Button
    Friend WithEvents cmdClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cmdClear = New System.Windows.Forms.Button
        Me.cmdPosition = New System.Windows.Forms.Button
        Me.cmdBlink = New System.Windows.Forms.Button
        Me.cmdClose = New System.Windows.Forms.Button
        Me.optLine1 = New System.Windows.Forms.RadioButton
        Me.optLine2 = New System.Windows.Forms.RadioButton
        Me.SuspendLayout()
        '
        'cmdClear
        '
        Me.cmdClear.Location = New System.Drawing.Point(16, 37)
        Me.cmdClear.Name = "cmdClear"
        Me.cmdClear.Size = New System.Drawing.Size(104, 21)
        Me.cmdClear.TabIndex = 0
        Me.cmdClear.Text = "Clear"
        '
        'cmdPosition
        '
        Me.cmdPosition.Location = New System.Drawing.Point(16, 74)
        Me.cmdPosition.Name = "cmdPosition"
        Me.cmdPosition.Size = New System.Drawing.Size(104, 21)
        Me.cmdPosition.TabIndex = 1
        Me.cmdPosition.Text = "Specify Position"
        '
        'cmdBlink
        '
        Me.cmdBlink.Location = New System.Drawing.Point(16, 111)
        Me.cmdBlink.Name = "cmdBlink"
        Me.cmdBlink.Size = New System.Drawing.Size(104, 21)
        Me.cmdBlink.TabIndex = 2
        Me.cmdBlink.Text = "Blink Characters"
        '
        'cmdClose
        '
        Me.cmdClose.Location = New System.Drawing.Point(200, 15)
        Me.cmdClose.Name = "cmdClose"
        Me.cmdClose.Size = New System.Drawing.Size(75, 21)
        Me.cmdClose.TabIndex = 3
        Me.cmdClose.Text = "Close"
        '
        'optLine1
        '
        Me.optLine1.Checked = True
        Me.optLine1.Location = New System.Drawing.Point(136, 59)
        Me.optLine1.Name = "optLine1"
        Me.optLine1.Size = New System.Drawing.Size(155, 22)
        Me.optLine1.TabIndex = 4
        Me.optLine1.TabStop = True
        Me.optLine1.Text = "DM-D 1st Line"
        '
        'optLine2
        '
        Me.optLine2.Location = New System.Drawing.Point(136, 81)
        Me.optLine2.Name = "optLine2"
        Me.optLine2.Size = New System.Drawing.Size(155, 22)
        Me.optLine2.TabIndex = 5
        Me.optLine2.Text = "DM-D 2nd Line"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 166)
        Me.Controls.Add(Me.optLine2)
        Me.Controls.Add(Me.optLine1)
        Me.Controls.Add(Me.cmdClose)
        Me.Controls.Add(Me.cmdBlink)
        Me.Controls.Add(Me.cmdPosition)
        Me.Controls.Add(Me.cmdClear)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Step1 Alphameric characters display"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The executed function when the Clear button is clicked.
    Private Sub cmdClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear.Click
        pdDisplayClear = New PrintDocument
        pdDisplayClear.PrintController = New StandardPrintController 'To disable pop-up window that shows the printing progress
        SetFont()
        pdDisplayClear.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayClear.Print()
    End Sub

    ' The executed function when the Position button is clicked.
    Private Sub cmdPosition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPosition.Click
        pdDisplayPosition = New PrintDocument
        pdDisplayPosition.PrintController = New StandardPrintController 'To disable pop-up window that shows the printing progress
        SetFont()
        pdDisplayPosition.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayPosition.Print()
    End Sub

    ' The executed function when the Blink button is clicked.
    Private Sub cmdBlink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBlink.Click
        pdDisplayBlink = New PrintDocument
        pdDisplayBlink.PrintController = New StandardPrintController 'To disable pop-up window that shows the printing progress
        SetFont()
        pdDisplayBlink.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayBlink.Print()
    End Sub

    ' Sets the Font variables to be used in printing.
    Private Sub SetFont()
        controlFont = New Font("Consolas", 9) 'Substituted to Control Font
        If optLine1.Checked = True Then
            DMDLineFont = New Font("Lucida Console", 8.5, FontStyle.Regular) 'Substituted to DM-D 1st Line Font
        Else
            DMDLineFont = New Font("Courier New", 8.5, FontStyle.Regular) 'Substituted to DM-D 2nd Line Font
        End If
    End Sub

    ' The event handler function when pdDisplayClear.Print is called.
    ' This is where the actual sending of Clear command to the display is made.
    Private Sub pdDisplayClear_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayClear.PrintPage
        ' Send the character for Clear command ("a") with the Control Font.
        ' Positions of x and y are not important, thus, setting them to zeroes.
        e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0)
        e.Graphics.DrawString(CMD_BLINKRESET, controlFont, Brushes.Black, 0, 0)
        e.HasMorePages = False
    End Sub

    ' The event handler function when pdDisplayPosition.Print is called.
    ' This is where the actual sending of string to display is made.
    Private Sub pdDisplayPosition_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayPosition.PrintPage
        ' Clear the display first before displaying the string.
        e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0)

        ' Send the string to the Display with DM-D 1st Line or DM-D 2nd Line font, 
        ' depending on the choosen line by the user.
        ' Positions of x and y are not important, thus, setting them to zeroes.
        e.Graphics.DrawString("Hello APD!", DMDLineFont, Brushes.Black, 0, 0)
        e.HasMorePages = False
    End Sub

    ' The event handler function when pdDisplayBlink.Print is called.
    ' This is where the actual sending of Blink command to the display is made.
    Private Sub pdDisplayBlink_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayBlink.PrintPage
        e.Graphics.DrawString(CMD_CLEAR, controlFont, Brushes.Black, 0, 0)
        e.Graphics.DrawString(CMD_BLINK, controlFont, Brushes.Black, 0, 0)

        e.Graphics.DrawString("Hello APD!", DMDLineFont, Brushes.Black, 0, 0)
        e.HasMorePages = False
    End Sub

    ' The executed function when the Close button is clicked.
    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Close()
    End Sub
End Class
