﻿Imports System.Drawing.Printing

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private Const DISPLAY_NAME As String = "EPSON DM-D70 Display"        ' DM-D Printer name
    Private Const CMD_CLEAR As String = "a"                              ' Control font "a"(clear display)
    Private Const CMD_SLIDE_SHOW_ON As String = "!"                      ' Control font "!"(start slide show)
    Private Const CMD_SLIDE_SHOW_OFF As String = """"                    ' Control font """(stop slide show)

    Private Const CMD_LAYOUT_CHAR As String = "P"                        ' ControlA font "L"(layout initialization)
    Private Const CMD_RED_CHAR As String = "R"                           ' ControlA font "R"(red character)
    Private Const CMD_ORG_CHAR As String = "B"                           ' ControlA font "B"(black character)

    ' Font definition
    ' Use the font name set in [Font Replacement] (Refer to APD6_DMD_Setup manual)
    ' Important:The number of point should be 2
    Dim ControlFont As Font = New Font("Consolas", 2, FontStyle.Regular)
    Dim ControlAFont As Font = New Font("Courier New", 2, FontStyle.Regular)
    Dim DMDCharacter As Font = New Font("MS Gothic", 2, FontStyle.Regular)
    Dim QRCodeFont As Font = New Font("Lucida Console", 2, FontStyle.Regular)

    ' Define display settings
    ' Image area size(Required for displaying image)
    ' Refer to Technical Reference Guide for the value
    Private Const ImageAreaW As Integer = 480
    Private Const ImageAreaH As Integer = 400

    ' Text area size(Required for displaying QR code)
    ' Refer to Technical Reference Guide for the value
    Private Const TextAreaW As Integer = 480
    Private Const TextAreaH As Integer = 400

    ' QR code size(Required for displaying QR code)
    ' Refer to Technical Reference Guide for the value
    Private Const QRCodeW As Integer = 87
    Private Const QRCodeH As Integer = 87

    Private WithEvents pdDisplayInitial As PrintDocument
    Private WithEvents pdDisplayItem As PrintDocument
    Private WithEvents pdDisplayTotal As PrintDocument
    Private WithEvents pdDisplayClear As PrintDocument

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()
        InitializeDisplay()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer
    Friend WithEvents cmdClear As System.Windows.Forms.Button
    Friend WithEvents cmdItem As System.Windows.Forms.Button
    Friend WithEvents cmdTotal As System.Windows.Forms.Button
    Friend WithEvents cmdClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cmdClear = New System.Windows.Forms.Button()
        Me.cmdItem = New System.Windows.Forms.Button()
        Me.cmdTotal = New System.Windows.Forms.Button()
        Me.cmdClose = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'cmdClear
        '
        Me.cmdClear.Location = New System.Drawing.Point(96, 60)
        Me.cmdClear.Name = "cmdClear"
        Me.cmdClear.Size = New System.Drawing.Size(114, 32)
        Me.cmdClear.TabIndex = 0
        Me.cmdClear.Text = "Clear"
        '
        'cmdItem
        '
        Me.cmdItem.Location = New System.Drawing.Point(24, 12)
        Me.cmdItem.Name = "cmdItem"
        Me.cmdItem.Size = New System.Drawing.Size(114, 32)
        Me.cmdItem.TabIndex = 1
        Me.cmdItem.Text = "Display Item"
        '
        'cmdTotal
        '
        Me.cmdTotal.Location = New System.Drawing.Point(176, 12)
        Me.cmdTotal.Name = "cmdTotal"
        Me.cmdTotal.Size = New System.Drawing.Size(114, 32)
        Me.cmdTotal.TabIndex = 2
        Me.cmdTotal.Text = "Display Total"
        '
        'cmdClose
        '
        Me.cmdClose.Location = New System.Drawing.Point(205, 121)
        Me.cmdClose.Name = "cmdClose"
        Me.cmdClose.Size = New System.Drawing.Size(75, 21)
        Me.cmdClose.TabIndex = 3
        Me.cmdClose.Text = "Close"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(332, 150)
        Me.Controls.Add(Me.cmdClose)
        Me.Controls.Add(Me.cmdTotal)
        Me.Controls.Add(Me.cmdItem)
        Me.Controls.Add(Me.cmdClear)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Step4 Portrait Sample"
        Me.ResumeLayout(False)

    End Sub

#End Region
    ' Set the layout of the customer display with controlA font
    Private Sub InitializeDisplay()
        pdDisplayInitial = New PrintDocument
        pdDisplayInitial.PrintController = New StandardPrintController 'Disable the pop-up window that displays the print progress
        pdDisplayInitial.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayInitial.Print()
    End Sub

    '"Display Item" button processing
    Private Sub cmdPosition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdItem.Click
        pdDisplayItem = New PrintDocument
        pdDisplayItem.PrintController = New StandardPrintController 'Disable the pop-up window that displays the print progress
        pdDisplayItem.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayItem.Print()
    End Sub

    '"Display Total" button processing
    Private Sub cmdBlink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdTotal.Click
        pdDisplayTotal = New PrintDocument
        pdDisplayTotal.PrintController = New StandardPrintController 'Disable the pop-up window that displays the print progress
        pdDisplayTotal.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayTotal.Print()
    End Sub

    '"Clear" button processing
    Private Sub cmdClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear.Click
        pdDisplayClear = New PrintDocument
        pdDisplayClear.PrintController = New StandardPrintController 'Disable the pop-up window that displays the print progress
        pdDisplayClear.PrinterSettings.PrinterName = DISPLAY_NAME
        pdDisplayClear.Print()
    End Sub

    ' Callback function registered in layout settings
    Private Sub pdDisplayInitial_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayInitial.PrintPage
		' Set layout of a display using a controlA font.
		' It is recommended to set the charecter color and background color.
		' The registry file attached to the sample program has the following settings.
		' - Display mode  ( US (K fn=1 )
		' - Character color ( US (G n=35 )
		' - Background color ( US (H n=35 )
        e.Graphics.DrawString(CMD_LAYOUT_CHAR, ControlAFont, Brushes.Black, 1, 1)
        e.HasMorePages = False
    End Sub

    'Callback function registered by "Display Item" button processing
    Private Sub pdDisplayItem_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayItem.PrintPage
        ' Important:Assign GraphicsUnit.Pixel to PageUnit
        e.Graphics.PageUnit = GraphicsUnit.Pixel

        ' Use the DrawString function to process control font, controlA font and DM-D Character fonts
        ' Important:The processing is performed in the order in which the DrawString function is called
        ' When using control font and controlA font, the coordinate specification of DrawString function is ignored

        ' Important: It is recommended to clear the display before displaying the text, 
        ' as whitespace characters may not be handled in the .NET environment
        ' Clear the display using the control font
        e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1)
        ' Start a slide show using the control font
        e.Graphics.DrawString(CMD_SLIDE_SHOW_ON, ControlFont, Brushes.Black, 1, 1)

        ' Important:Specify the start column line of the text as the start coordinate of the DrawString function
        ' Important:Do not specify more than one line of text in a DrawString function
        e.Graphics.DrawString("Item:               ", DMDCharacter, Brushes.Black, 1, 1)
        e.Graphics.DrawString("  Cut & Sewn        ", DMDCharacter, Brushes.Black, 1, 2)
        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 3)
        e.Graphics.DrawString("QTY:              3 ", DMDCharacter, Brushes.Black, 1, 4)
        e.Graphics.DrawString("U.PC:        $45.00 ", DMDCharacter, Brushes.Black, 1, 5)

        ' Change the font color to red using the controlA font.
        e.Graphics.DrawString(CMD_RED_CHAR, ControlAFont, Brushes.Black, 1, 1)

        e.Graphics.DrawString("             -22.50 ", DMDCharacter, Brushes.Black, 1, 6)

        ' Restore font color using the controlA font
        e.Graphics.DrawString(CMD_ORG_CHAR, ControlAFont, Brushes.Black, 1, 1)

        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 7)
        e.Graphics.DrawString("SubTotal:    $67.50 ", DMDCharacter, Brushes.Black, 1, 8)

        e.HasMorePages = False

    End Sub

    ' Callback function registered by "Display Total" button processing
    Private Sub pdDisplayTotal_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayTotal.PrintPage
        ' Important:Assign GraphicsUnit.Pixel to PageUnit
        e.Graphics.PageUnit = GraphicsUnit.Pixel

        ' Use the DrawString function to process control font, controlA font and DM-D Character font
        ' Important:The processing is performed in the order in which the DrawString function is called
        ' When using control font and controlA font, the coordinate specification of DrawString function is ignored

        ' Important: It is recommended to clear the display before displaying the text, 
        ' as whitespace characters may not be handled in the .NET environment
        ' Clear the display using the control font
        e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1)
        ' Stop a slide show using the control font
        e.Graphics.DrawString(CMD_SLIDE_SHOW_OFF, ControlFont, Brushes.Black, 1, 1)

        ' Important:Specify the start column line of the text as the start coordinate of the DrawString function
        e.Graphics.DrawString("Total:        $67.50", DMDCharacter, Brushes.Black, 1, 1)
        e.Graphics.DrawString("Cash:        $100.00", DMDCharacter, Brushes.Black, 1, 2)
        e.Graphics.DrawString("Change:       $32.50", DMDCharacter, Brushes.Black, 1, 3)
        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 4)
        e.Graphics.DrawString("  Store Information ", DMDCharacter, Brushes.Black, 1, 5)
        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 6)
        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 7)
        e.Graphics.DrawString("                    ", DMDCharacter, Brushes.Black, 1, 8)

        ' Display QR code using QR code font and DrawString function
        ' Important:For the coordinates of the TextOut function, specify the coordinates of the upper left corner of the QR code to be displayed
        ' Important:At this time, the origin is the upper left corner of the text area
        ' Important:QR code can be displayed only in the text area
        Dim x As Integer = (TextAreaW / 2) - (QRCodeW / 2) 'Center of text area
        Dim y As Integer = TextAreaH - QRCodeH                 'Bottom of text area

        e.Graphics.DrawString("https:'epson.jp", QRCodeFont, Brushes.Black, x, y)

        ' Display an image with the DrawImage function
        ' For the coordinates of the DrawImage function, specify the coordinates of the upper left corner of the image to be displayed
        ' At this time, the origin is the upper left corner of the image area
        ' Important:Images can be displayed only in the image area, and only the display in the entire image area is supported
        ' (That is, the starting coordinate is always (0,0))

        ' * This sample is implemented on the assumption that the size of the image area and the size of the displayed image are the same

        Dim img As Image = New Bitmap("ThankP.png")
        Dim destRect As Rectangle = New Rectangle(0, 0, ImageAreaW, ImageAreaH)

        ' Important:Assign -1 to the width and height of the input image. 
        ' Because in the .NET environment, if the input image and output image are the same size, the drawing function may not be called.
        e.Graphics.DrawImage(img, destRect, 0, 0, ImageAreaW - 1, ImageAreaH - 1, GraphicsUnit.Pixel)

        img.Dispose()

        e.HasMorePages = False
    End Sub

    ' Callback function registered by "Clear" button processing
    Private Sub pdDisplayClear_Print(ByVal sender As System.Object, ByVal e As PrintPageEventArgs) Handles pdDisplayClear.PrintPage
        e.Graphics.DrawString(CMD_CLEAR, ControlFont, Brushes.Black, 1, 1)
        e.HasMorePages = False
    End Sub


    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Close()
    End Sub
End Class
