using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;
using com.epson.pos.driver;

namespace Program09
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button cmdClose;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Button cmdPrint;
		internal System.Windows.Forms.PictureBox pbImage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		// Constant variable holding the printer name.
		private const string PRINTER_NAME = "EPSON TM-T88V Receipt";

		// Variables/Objects.
        private StatusAPI m_objAPI;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            m_objAPI = new StatusAPI();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.cmdClose = new System.Windows.Forms.Button();
            this.GroupBox1 = new System.Windows.Forms.GroupBox();
            this.cmdPrint = new System.Windows.Forms.Button();
            this.pbImage = new System.Windows.Forms.PictureBox();
            this.GroupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pbImage)).BeginInit();
            this.SuspendLayout();
            // 
            // cmdClose
            // 
            this.cmdClose.Location = new System.Drawing.Point(258, 88);
            this.cmdClose.Name = "cmdClose";
            this.cmdClose.Size = new System.Drawing.Size(75, 23);
            this.cmdClose.TabIndex = 13;
            this.cmdClose.Text = "Close";
            this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
            // 
            // GroupBox1
            // 
            this.GroupBox1.Controls.Add(this.cmdPrint);
            this.GroupBox1.Location = new System.Drawing.Point(10, 11);
            this.GroupBox1.Name = "GroupBox1";
            this.GroupBox1.Size = new System.Drawing.Size(323, 74);
            this.GroupBox1.TabIndex = 12;
            this.GroupBox1.TabStop = false;
            this.GroupBox1.Text = "Receipt";
            // 
            // cmdPrint
            // 
            this.cmdPrint.Location = new System.Drawing.Point(125, 28);
            this.cmdPrint.Name = "cmdPrint";
            this.cmdPrint.Size = new System.Drawing.Size(75, 23);
            this.cmdPrint.TabIndex = 0;
            this.cmdPrint.Text = "Print";
            this.cmdPrint.Click += new System.EventHandler(this.cmdPrint_Click);
            // 
            // pbImage
            // 
            this.pbImage.Image = ((System.Drawing.Image)(resources.GetObject("pbImage.Image")));
            this.pbImage.Location = new System.Drawing.Point(10, 88);
            this.pbImage.Name = "pbImage";
            this.pbImage.Size = new System.Drawing.Size(64, 24);
            this.pbImage.TabIndex = 14;
            this.pbImage.TabStop = false;
            this.pbImage.Visible = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(345, 124);
            this.Controls.Add(this.pbImage);
            this.Controls.Add(this.cmdClose);
            this.Controls.Add(this.GroupBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Step 5   Status Monitoring/Error Handling";
            this.GroupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pbImage)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// The executed function when the Print button is clicked.
		private void cmdPrint_Click(object sender, System.EventArgs e)
        {
            PrintDocument pdPrint = new PrintDocument();
            pdPrint.PrintPage += new PrintPageEventHandler(pdPrint_PrintPage);
            pdPrint.PrinterSettings.PrinterName = PRINTER_NAME;

            try
            {
                // Open a printer status monitor for the selected printer.
                if(m_objAPI.OpenMonPrinter(OpenType.TYPE_PRINTER, PRINTER_NAME) == ErrorCode.SUCCESS)
                {
                    // Change the printer to the indicated printer.
                    pdPrint.PrinterSettings.PrinterName = PRINTER_NAME;

                    if(pdPrint.PrinterSettings.IsValid)
                    {
                        pdPrint.DocumentName = "Testing";
                        // Start printing
                        pdPrint.Print();

                        // Check printing status.
                        StatusMonitoring();
                    }
                    else
                        MessageBox.Show("Printer is not available.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                    // Always close the Status Monitor after using the Status API.
                    if(m_objAPI.CloseMonPrinter() != ErrorCode.SUCCESS)
                        MessageBox.Show("Failed to close printer status monitor.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                    MessageBox.Show("Failed to open printer status monitor.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            catch
            {
                MessageBox.Show("Failed to open StatusAPI.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }            
		}

		// The event handler function when pdPrint.Print is called.
		// This is where the actual printing of sample data to the printer.
		private void pdPrint_PrintPage(object sender, PrintPageEventArgs e)
        {
            float x, y, lineOffset;

            // Instantiate font objects used in printing.
            Font printFont = new Font("Lucida Console", (float)8, FontStyle.Regular, GraphicsUnit.Point); // Substituted to FontA Font

            e.Graphics.PageUnit = GraphicsUnit.Point;

            // Draw the bitmap
            x = 79;
            y = 0;
            e.Graphics.DrawImage(pbImage.Image, x, y, pbImage.Image.Width - 13, pbImage.Image.Height - 10);

            // Print the receipt text
            lineOffset = printFont.GetHeight(e.Graphics) - (float)3.5;
            x = 10;
            y = 24 + lineOffset;
            e.Graphics.DrawString("123xxstreet,xxxcity,xxxxstate", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("        TEL   9999-99-9999       C#2", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("    November.23, 2007     PM 4:24", printFont, Brushes.Black, x, y);
            y = y + (lineOffset * (float)5);
            e.Graphics.DrawString("apples                       $20.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("grapes                       $30.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("bananas                      $40.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("lemons                       $50.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("oranges                      $60.00", printFont, Brushes.Black, x, y);
            y += (lineOffset * (float)5);
            e.Graphics.DrawString("Tax excluded.               $200.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("Tax     5.0%                 $10.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("___________________________________", printFont, Brushes.Black, x, y);

            printFont = new Font("MingLiU", 19, FontStyle.Regular, GraphicsUnit.Point);
            lineOffset = printFont.GetHeight(e.Graphics) - 3;
            y += lineOffset;
            e.Graphics.DrawString("Total     $210.00", printFont, Brushes.Black, x - 1, y);

            printFont = new Font("Lucida Console", (float)8, FontStyle.Regular, GraphicsUnit.Point);
            lineOffset = printFont.GetHeight(e.Graphics);
            y = y + lineOffset + 1;
            e.Graphics.DrawString("Customer's payment         $250.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("Change                      $40.00", printFont, Brushes.Black, x, y - 2);

            // Indicate that no more data to print, and the Print Document can now send the print data to the spooler.
            e.HasMorePages = false;
		}

        // Checks the printer status.
		private void StatusMonitoring()
        {
            Boolean isFinish = false, cancelErr = false;
            ASB printerStatus;

            do
            {
                printerStatus = m_objAPI.Status;
                
                // Notify printing completion.
                if (printerStatus.ToString().Contains(ASB.ASB_PRINT_SUCCESS.ToString()))
                {
                    MessageBox.Show("Printing complete.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    isFinish = true;
                }
                else
                {
                    // Notify any errors that occur.
                    if (printerStatus.ToString().Contains(ASB.ASB_COVER_OPEN.ToString()))
                    {
                        MessageBox.Show("Cover is open.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        isFinish = true;
                        cancelErr = true;
                    }
                    else if (printerStatus.ToString().Contains(ASB.ASB_AUTOCUTTER_ERR.ToString()))
                    {
                        MessageBox.Show("Autocutter error occurred.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        isFinish = true;
                        cancelErr = true;
                    }
                    else if (printerStatus.ToString().Contains(ASB.ASB_NO_RESPONSE.ToString()))
                    {
                        MessageBox.Show("No response.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        isFinish = true;
                        cancelErr = true;
                    }
                    else if (printerStatus.ToString().Contains(ASB.ASB_PAPER_END.ToString()))
                    {
                        MessageBox.Show("Roll paper end sensor: paper not present.", "Program07", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        isFinish = true;
                        cancelErr = true;
                    }

                    // If an error occured, call BiCancelError or BiResetPrinter.
                    if (cancelErr)
                        m_objAPI.CancelError();
                }
            }while(!isFinish);
        }

		// The executed function when the Close button is clicked.
		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
