using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Printing;
using com.epson.pos.driver;

namespace Program09
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button cmdClose;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Button cmdPrint;
		internal System.Windows.Forms.PictureBox pbImage;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		
		// Constant variable holding the printer name.
		private const string PRINTER_NAME = "EPSON TM-T88V Receipt";

		// Variables/Objects.
        private StatusAPI m_objAPI;
		Boolean isFinish;
		Boolean cancelErr;
		ASB printStatus;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            m_objAPI = new StatusAPI();
            // Associate the created callback function to the event handler of StatusAPI.
            m_objAPI.StatusCallback += new StatusAPI.StatusCallbackHandler(StatusMonitoring);
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.cmdClose = new System.Windows.Forms.Button();
            this.GroupBox1 = new System.Windows.Forms.GroupBox();
            this.cmdPrint = new System.Windows.Forms.Button();
            this.pbImage = new System.Windows.Forms.PictureBox();
            this.GroupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pbImage)).BeginInit();
            this.SuspendLayout();
            // 
            // cmdClose
            // 
            this.cmdClose.Location = new System.Drawing.Point(260, 89);
            this.cmdClose.Name = "cmdClose";
            this.cmdClose.Size = new System.Drawing.Size(75, 23);
            this.cmdClose.TabIndex = 13;
            this.cmdClose.Text = "Close";
            this.cmdClose.Click += new System.EventHandler(this.cmdClose_Click);
            // 
            // GroupBox1
            // 
            this.GroupBox1.Controls.Add(this.cmdPrint);
            this.GroupBox1.Location = new System.Drawing.Point(10, 10);
            this.GroupBox1.Name = "GroupBox1";
            this.GroupBox1.Size = new System.Drawing.Size(325, 74);
            this.GroupBox1.TabIndex = 12;
            this.GroupBox1.TabStop = false;
            this.GroupBox1.Text = "Receipt";
            // 
            // cmdPrint
            // 
            this.cmdPrint.Location = new System.Drawing.Point(123, 26);
            this.cmdPrint.Name = "cmdPrint";
            this.cmdPrint.Size = new System.Drawing.Size(75, 23);
            this.cmdPrint.TabIndex = 0;
            this.cmdPrint.Text = "Print";
            this.cmdPrint.Click += new System.EventHandler(this.cmdPrint_Click);
            // 
            // pbImage
            // 
            this.pbImage.Image = ((System.Drawing.Image)(resources.GetObject("pbImage.Image")));
            this.pbImage.Location = new System.Drawing.Point(10, 88);
            this.pbImage.Name = "pbImage";
            this.pbImage.Size = new System.Drawing.Size(64, 24);
            this.pbImage.TabIndex = 14;
            this.pbImage.TabStop = false;
            this.pbImage.Visible = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(345, 124);
            this.Controls.Add(this.pbImage);
            this.Controls.Add(this.cmdClose);
            this.Controls.Add(this.GroupBox1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Step7  Drawer control";
            this.GroupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.pbImage)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// The executed function when the Print button is clicked.
		private void cmdPrint_Click(object sender, System.EventArgs e)
        {
            PrintDocument pdPrint = new PrintDocument();
			pdPrint.PrintPage += new PrintPageEventHandler(pdPrint_PrintPage);
			pdPrint.PrinterSettings.PrinterName = PRINTER_NAME;
            
            try
            {
                // Open a printer status monitor for the selected printer.
                if (m_objAPI.OpenMonPrinter(OpenType.TYPE_PRINTER, pdPrint.PrinterSettings.PrinterName) == ErrorCode.SUCCESS)
                {
                    isFinish = false;
                    cancelErr = false;

                    // Set the callback function that will monitor printer status.
                    if (m_objAPI.SetStatusBack() == ErrorCode.SUCCESS)
                    {
                        if (pdPrint.PrinterSettings.IsValid)
                        {
                            pdPrint.DocumentName = "Testing";
                            // Start printing.
                            pdPrint.Print();

                            // Wait until callback function will say that the task is done.
                            // When done, end the monitoring of printer status.
                            do
                            {
                                if (isFinish)
                                    // End the monitoring of printer status.
                                    m_objAPI.CancelStatusBack();
                            } while (!isFinish);

                            // Display the status/error message.
                            DisplayStatusMessage();

                            // If an error occurred, restore the recoverable error.
                            if (cancelErr)
                                m_objAPI.CancelError();
                            else
                                // If the printing completed, call BiOpenDrawer from the Status API to perform the drawer kick.
                                OpenDrawer(pdPrint.PrinterSettings.PrinterName);
                        }
                        else
                            MessageBox.Show("Printer is not available.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
                    }
                    else
                        MessageBox.Show("Failed to set callback function.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                    // Always close the Status Monitor after using the Status API.
                    if (m_objAPI.CloseMonPrinter() != ErrorCode.SUCCESS)
                        MessageBox.Show("Failed to close printer status monitor.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                    MessageBox.Show("Failed to open printer status monitor.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			catch 
			{
                MessageBox.Show("Failed to open StatusAPI.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
            
		}

		// The event handler function when pdPrint.Print is called.
		// This is where the actual printing of sample data to the printer.
		private void pdPrint_PrintPage(object sender, PrintPageEventArgs e)
        {
            float x, y, lineOffset;

            // Instantiate font objects used in printing.
            Font printFont = new Font("Lucida Console", (float)8, FontStyle.Regular, GraphicsUnit.Point); // Substituted to FontA Font

            e.Graphics.PageUnit = GraphicsUnit.Point;

            // Draw the bitmap
            x = 79;
            y = 0;
            e.Graphics.DrawImage(pbImage.Image, x, y, pbImage.Image.Width - 13, pbImage.Image.Height - 10);

            // Print the receipt text
            lineOffset = printFont.GetHeight(e.Graphics) - (float)3.5;
            x = 10;
            y = 24 + lineOffset;
            e.Graphics.DrawString("123xxstreet,xxxcity,xxxxstate", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("        TEL   9999-99-9999       C#2", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("    November.23, 2007     PM 4:24", printFont, Brushes.Black, x, y);
            y = y + (lineOffset * (float)5);
            e.Graphics.DrawString("apples                       $20.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("grapes                       $30.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("bananas                      $40.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("lemons                       $50.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("oranges                      $60.00", printFont, Brushes.Black, x, y);
            y += (lineOffset * (float)5);
            e.Graphics.DrawString("Tax excluded.               $200.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("Tax     5.0%                 $10.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("___________________________________", printFont, Brushes.Black, x, y);

            printFont = new Font("MingLiU", 19, FontStyle.Regular, GraphicsUnit.Point);
            lineOffset = printFont.GetHeight(e.Graphics) - 3;
            y += lineOffset;
            e.Graphics.DrawString("Total     $210.00", printFont, Brushes.Black, x - 1, y);

            printFont = new Font("Lucida Console", (float)8, FontStyle.Regular, GraphicsUnit.Point);
            lineOffset = printFont.GetHeight(e.Graphics);
            y = y + lineOffset + 1;
            e.Graphics.DrawString("Customer's payment         $250.00", printFont, Brushes.Black, x, y);
            y += lineOffset;
            e.Graphics.DrawString("Change                      $40.00", printFont, Brushes.Black, x, y - 2);

            // Indicate that no more data to print, and the Print Document can now send the print data to the spooler.
            e.HasMorePages = false;
		}

        // The callback function that will monitor printer/printing status.
        public void StatusMonitoring(ASB status)
        {
            if (status.ToString().Contains(ASB.ASB_PRINT_SUCCESS.ToString()))
            {
                printStatus = status;
                isFinish = true;
            }
            if (status.ToString().Contains(ASB.ASB_NO_RESPONSE.ToString()) ||
                status.ToString().Contains(ASB.ASB_COVER_OPEN.ToString()) ||
                status.ToString().Contains(ASB.ASB_AUTOCUTTER_ERR.ToString()) ||
                status.ToString().Contains(ASB.ASB_PAPER_END.ToString()))
            {
                printStatus = status;
                isFinish = true;
                cancelErr = true;
            }
        }

		// Open the cash drawer using the Status API.
		private void OpenDrawer(String printerName)
		{
			try
			{
				// Execute drawer operation.
                if (m_objAPI.OpenDrawer(Drawer.EPS_BI_DRAWER_1, Pulse.EPS_BI_PULSE_100) != ErrorCode.SUCCESS)
                    MessageBox.Show("Failed to open drawer.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
			catch
			{
                MessageBox.Show("Failed to open drawer.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

        private void DisplayStatusMessage()
        {
            if (this.printStatus.ToString().Contains(ASB.ASB_PRINT_SUCCESS.ToString()))
                MessageBox.Show("Printing complete.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Information);
            else if (this.printStatus.ToString().Contains(ASB.ASB_NO_RESPONSE.ToString()))
                MessageBox.Show("No response.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (this.printStatus.ToString().Contains(ASB.ASB_COVER_OPEN.ToString()))
                MessageBox.Show("Cover is open.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (this.printStatus.ToString().Contains(ASB.ASB_AUTOCUTTER_ERR.ToString()))
                MessageBox.Show("Autocutter error occurred.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            else if (this.printStatus.ToString().Contains(ASB.ASB_PAPER_END.ToString()))
                MessageBox.Show("Roll paper end sensor: paper not present.", "Program09", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

		// The executed function when the Close button is clicked.
		private void cmdClose_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
