using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using com.epson.pos.driver;


namespace Program12
{
    public partial class Form1 : Form
    {        
        // Constant variable holding the Printer name.
        private const string PRINTER_NAME = "EPSON TM-T88V Receipt";

        public Form1()
        {
            InitializeComponent();
        }

        // The executed function when the Display button is clicked.
        private void cmdDisplay_Click(object sender, EventArgs e)
        {
            StatusAPI m_objAPI = new StatusAPI();
            int autoCutTimes = 0;

            try
            {
                // Open a printer status monitor for the selected printer.
                if (m_objAPI.OpenMonPrinter(OpenType.TYPE_PRINTER, PRINTER_NAME) == ErrorCode.SUCCESS)
                {
                    // Get the maintenance counter, only for the Paper Cut counter.
                    if (m_objAPI.GetCounter(CounterIndex.PAPER_CUT, true, out autoCutTimes) == ErrorCode.SUCCESS)
                        // Display the acquired number of Auto-cut operations.
                        txtAutoCutter.Text = autoCutTimes.ToString();
                    else
                        MessageBox.Show("Failed to get maintenance counter.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);

                    // Always close the Status Monitor after using the Status API.
                    if (m_objAPI.CloseMonPrinter() != ErrorCode.SUCCESS)
                        MessageBox.Show("Failed to close printer status monitor.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                    MessageBox.Show("Failed to open printer status monitor.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            catch
            {
                MessageBox.Show("Failed to open StatusAPI.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        // The executed function when the Close button is clicked.
        private void cmdClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}