#pragma once

#include "EpsStmApi.h"
#include "StatusAPI.h"

// Printer definitions
#define	EPS_PRINTER_NAME	"EPSON TM-H6000VI Slip"

// Define error bit patterns for MICR reading
#define BIT_ERR_READERROR		0x0020

// Callback function definition
int CALLBACK EXPORT CBMICRRead(void);

// Bit masks for Type ID acquired through BiGetType
#define	BITMASK_WITHMICR		0x0008
#define	BITMASK_MICREQUIPPED	0x0008
#define	BITMASK_MICRSELECT		0x0004

// CDisplayDlg dialog

class CDisplayDlg : public CDialog
{
	DECLARE_DYNAMIC(CDisplayDlg)

public:
	CDisplayDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDisplayDlg();

// Dialog Data
	enum { IDD = IDD_COUNTER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

	BOOL StartOperation();
	void EndOperation();

	BOOL ReadMICR();

	CStatusAPI	m_statAPI;
	int			m_nHandle;
	BYTE		m_readCharBuff[200];
	BYTE		m_readBuffSize;
	BYTE		m_status;
	BYTE		m_detail;

	BOOL		m_isInitialized;
	BOOL		m_needCloseMonPrinter;
	BOOL		m_needMICRCancelReadBack;

public:
	afx_msg void OnBnClickedButtonRead();
	afx_msg void OnBnClickedButtonRemove();
};
