#pragma once

#include "EpsStmApi.h"
#include "StatusAPI.h"

// Slip and endorse printer definitions
#define	EPS_SLIPPRINTER_NAME	"EPSON TM-H6000VI Slip"
#define EPS_ENDORSEPRINTER_NAME	"EPSON TM-H6000VI Endorse"

// Define error bit patterns for MICR reading
#define BIT_ERR_READERROR		0x0020

// Bit masks for Type ID acquired through BiGetType
#define	BITMASK_WITHMICR		0x0008
#define	BITMASK_MICREQUIPPED	0x0008

// Line offset for printing
#define	LINE_OFFSET				20

// Callback function definition
int CALLBACK EXPORT CBPrinterStatus(DWORD dwStatus);
int CALLBACK EXPORT CBMICRRead(void);

// CDisplayDlg dialog

class CDisplayDlg : public CDialog
{
	DECLARE_DYNAMIC(CDisplayDlg)

public:
	CDisplayDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CDisplayDlg();

// Dialog Data
	enum { IDD = IDD_COUNTER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

	BOOL StartOperation();
	void EndOperation();
	
	BOOL ReadMICR();
	BOOL PrintEndorse();
	BOOL PrintSlip();
	void DisplayStatusMessage(DWORD dwPrintStatus);

	CStatusAPI	m_statAPI;
	int			m_nHandle;
	BYTE		m_readCharBuff[200];
	BYTE		m_readBuffSize;
	BYTE		m_status;
	BYTE		m_detail;

	BOOL		m_isInitialized;
	BOOL		m_needCloseMonPrinter;
	BOOL		m_needCancelStatusBack;
	BOOL		m_needMICRCancelReadBack;

public:
	afx_msg void OnBnClickedButtonRead();
};