// PrintDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Program03.h"
#include "PrintDlg.h"
#include ".\printdlg.h"


// CPrintDlg dialog

IMPLEMENT_DYNAMIC(CPrintDlg, CDialog)
CPrintDlg::CPrintDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrintDlg::IDD, pParent)
{
}

CPrintDlg::~CPrintDlg()
{
}

void CPrintDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CPrintDlg, CDialog)
	ON_BN_CLICKED(IDC_PRINT_BUTTON, OnBnClickedPrintButton)
#ifdef _WIN64
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, CPrintDlg::OnBnClickedCloseButton)
#else
	ON_BN_CLICKED(IDC_CLOSE_BUTTON, &CPrintDlg::OnBnClickedCloseButton)
#endif
END_MESSAGE_MAP()


// CPrintDlg message handlers

void CPrintDlg::OnBnClickedPrintButton()
{
	Print();
}

void CPrintDlg::Print() {
    DOCINFO di;

	/*
	 * Clean the document information structure
	 */
    memset(&di, 0, sizeof(DOCINFO));
    di.cbSize = sizeof(DOCINFO);
    di.lpszDocName = "Testing";

    CDC dc;
	/*
	 * Create the device context for printing
	 */
	if(! dc.CreateDC(NULL, EPS_PRINTER_NAME, NULL, NULL))
    {
		AfxMessageBox(_T("Printer is not available."));
		return;
    }
	
	LPTEXTMETRIC	lpMetrics = new TEXTMETRIC[1];
	LONG			lineOffset;

	dc.StartDoc(&di);
	CFont	font;
	CFont	*old;
	
	/*
	 * Create and select the Alphanumeric (FontA) device font
	 */
	font.CreatePointFont(95, "FontA11", &dc);

	old = dc.SelectObject(&font);
	dc.GetTextMetrics(lpMetrics);
	lineOffset = lpMetrics->tmHeight;

	int x = 30, y = 10;	
	/*
	 * Print the receipt text
	 */
	dc.TextOut(x, y, "123xxstreet,xxxcity,xxxxstate"); y += lineOffset;
	dc.TextOut(x, y, "        TEL   9999-99-9999       C#2");	y+= lineOffset;
	dc.TextOut(x, y, "    November.23, 2007     PM 4:24"); y+= (lineOffset*2);
	dc.TextOut(x, y, "apples                       $20.00"); y+= lineOffset;
	dc.TextOut(x, y, "grapes                       $30.00"); y+= lineOffset;
	dc.TextOut(x, y, "bananas                      $40.00"); y+= lineOffset;
	dc.TextOut(x, y, "lemons                       $50.00"); y+= lineOffset;
	dc.TextOut(x, y, "oranges                      $60.00"); y+= (lineOffset*2);
	dc.TextOut(x, y, "Tax excluded.               $200.00"); y+= lineOffset;
	dc.TextOut(x, y, "Tax     5.0%                 $10.00"); y+= lineOffset;
	dc.TextOut(x, y, "___________________________________"); 
	
	dc.SelectObject(old);
	font.DeleteObject();
	font.CreatePointFont(190, "FontA22", &dc);
	dc.SelectObject(&font);
	dc.GetTextMetrics(lpMetrics);
	lineOffset = lpMetrics->tmHeight;
	y+= lineOffset;
	dc.TextOut(x, y, "Total     $210.00"); y+= lineOffset;
	dc.SelectObject(old);
	font.DeleteObject();

	font.CreatePointFont(95, "FontA11", &dc);
	dc.SelectObject(&font);
	dc.GetTextMetrics(lpMetrics);
	lineOffset = lpMetrics->tmHeight;

	dc.TextOut(x, y, "Customer's payment         $250.00"); y+= lineOffset;
	dc.TextOut(x, y, "Change                      $40.00"); y+= (lineOffset*2);
	dc.SelectObject(old);
	font.DeleteObject();

	/*
	 * Draw the barcode using the Barcode device font
	 */
	font.CreatePointFont(650, "Barcode1", &dc);
	dc.SelectObject(&font);
	dc.GetTextMetrics(lpMetrics);
	lineOffset = lpMetrics->tmHeight;

	dc.TextOut(x+50, y, "012345678901");


	/*
	 * Add a space below the barcode
	 */
	y+= lineOffset;
	dc.TextOut(x, y, "       ");

	delete[] lpMetrics;

	/*
	 * Restore the previous font
	 */
	dc.SelectObject(old);
	font.DeleteObject();
	
    dc.EndPage();
    dc.EndDoc();
    dc.DeleteDC();
}
void CPrintDlg::OnBnClickedCloseButton()
{
	OnOK();
}
