// DisplayDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Program12.h"
#include "DisplayDlg.h"
#include "StatusAPI.h"
#include "EpsStmApi.h"

// CDisplayDlg dialog

IMPLEMENT_DYNAMIC(CDisplayDlg, CDialog)

CDisplayDlg::CDisplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayDlg::IDD, pParent)
{

}

CDisplayDlg::~CDisplayDlg()
{
}

void CDisplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CDisplayDlg, CDialog)
#ifdef _WIN64
	ON_BN_CLICKED(IDC_BUTTON_DISPLAY, CDisplayDlg::OnBnClickedButtonDisplay)
#else
	ON_BN_CLICKED(IDC_BUTTON_DISPLAY, &CDisplayDlg::OnBnClickedButtonDisplay)
#endif
END_MESSAGE_MAP()


// CDisplayDlg message handlers

void CDisplayDlg::OnBnClickedButtonDisplay()
{
	int nHandle;

	/*
	 * Initialize the Status API object. This loads the functions from EpsStmApi.dll
	 */
	if ( m_statAPI.Initialize() == FALSE ) {
		AfxMessageBox(_T("Failed to open StatusAPI."));
		return;
	}

	/*
	 * Open a printer status monitor for the selected printer
	 */
	nHandle = m_statAPI.BiOpenMonPrinter(TYPE_PRINTER, EPS_PRINTER_NAME);
	if ( nHandle < 0 ) {
		AfxMessageBox(_T("Failed to open printer status monitor."));
		return;
	}

	/*
	 * This feature of the StatusAPI allows reading of several maintenance counters.
	 * This can be used for checking the printer's physical condition.
	 * For a list of maintenance counters and what their values mean, see the Status API Manual.
	 */
	DWORD	readcounter;
	if ( m_statAPI.BiGetCounter(nHandle, MC_AUTOCUT_OPERATIONS, &readcounter) == SUCCESS ) {
		CString		strCounterVal;
		strCounterVal.Format("%d", readcounter);
		SetDlgItemText(IDC_EDIT_CTR, _T(strCounterVal));
	}
	else {
		AfxMessageBox(_T("Failed to get maintenance counter."));
	}

	/*
	 * Always close the Status Monitor after using the Status API
	 */
	if ( m_statAPI.BiCloseMonPrinter(nHandle) != SUCCESS ) {
		AfxMessageBox(_T("Failed to close printer status monitor."));
	}
}
