Imports com.epson.pos.driver

Public Class Form1

    ' Constant variable holding the Printer name.
    Private Const PRINTER_NAME = "EPSON TM-T88V Receipt"

    ' The executed function when the Display button is clicked.
    Private Sub cmdDisplay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisplay.Click
        Dim m_objAPI As New StatusAPI
        Dim autoCutTimes As Integer
        autoCutTimes = 0

        Try
            ' Open a printer status monitor for the selected printer.
            If m_objAPI.OpenMonPrinter(OpenType.TYPE_PRINTER, PRINTER_NAME) = ErrorCode.SUCCESS Then

                ' Get the maintenance counter, only for the Paper Cut counter.
                If m_objAPI.GetCounter(CounterIndex.PAPER_CUT, True, autoCutTimes) = ErrorCode.SUCCESS Then

                    ' Display the acquired number of Auto-cut operations.
                    txtAutoCutter.Text = autoCutTimes.ToString

                Else
                    MessageBox.Show("Failed to get maintenance counter.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If

                ' Always close the Status Monitor after using the Status API.
                If Not m_objAPI.CloseMonPrinter() = ErrorCode.SUCCESS Then
                    MessageBox.Show("Failed to close printer status monitor.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End If

            Else
                MessageBox.Show("Failed to open printer status monitor.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If

        Catch ex As Exception
            MessageBox.Show("Failed to open StatusAPI.", "Program12", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

    End Sub

    ' The executed function when the Close button is clicked.
    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Close()
    End Sub

End Class
